package com.gx.obe.common.widget.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;

import com.swtdesigner.SWTResourceManager;

public class ProgressDialog extends Dialog {

	protected Object result;
	protected Shell shell;
	private String message;
	private Label messageLabel;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public ProgressDialog(Shell parent, String message) {
		super(parent, SWT.NONE);
		this.message = message;
		setText(message);
	}

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() {
		createContents();
		shell.setMinimumSize(320, 110);
		shell.pack();
		SwtUtils.setCenter(shell);
		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}

	
	/**
	 * Create contents of the dialog.
	 */
	private void createContents() {
		shell = new Shell(getParent(), SWT.ON_TOP | SWT.NO_TRIM | SWT.APPLICATION_MODAL);
		shell.setSize(320, 110);
		shell.setText(getText());
		GridLayout gl_shell = new GridLayout(1, false);
		gl_shell.marginHeight = 20;
		gl_shell.marginWidth = 20;
		shell.setLayout(gl_shell);
		
		messageLabel = new Label(shell, SWT.NONE);
		messageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		messageLabel.setLayoutData(new GridData(SWT.CENTER, SWT.BOTTOM, true, true, 1, 1));
		messageLabel.setText(null != message ? message : "正在在线同步最新投标信息");
		
		ProgressBar progressBar = new ProgressBar(shell, SWT.SMOOTH | SWT.INDETERMINATE);
		GridData gd_progressBar = new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1);
		gd_progressBar.widthHint = 250;
		gd_progressBar.heightHint = 8;
		progressBar.setLayoutData(gd_progressBar);
	}

	
	public void close(){
		if(null != shell && !shell.isDisposed()){
			shell.close();
		}
	}
}
